#include <SD.h>
#include <SPI.h>
#include <pcmConfig.h>
#include <pcmRF.h>
#include <TMRpcm.h>


const int CS_PIN = 4;
const int SpeakerPin = 9;
String RootFile = "/";//MP3
const int Back_But = 5;
const int Play_But = 6;
const int Front_But = 7;

boolean Back_But_State = LOW ;
boolean Play_But_State = LOW ;
boolean Front_But_State = LOW ;

boolean BackPrevButState = LOW ;
boolean Play_Prev_But_State = LOW ;
boolean Front_Prev_But_State = LOW ;

const char BackChar = 'B';
const char PlayChar = 'P';
const char FrontChar = 'F';
const char NullChar = 'Q';
File SubFile;
File Root;

TMRpcm Audio;
void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  pinMode(CS_PIN, OUTPUT);
  SD.begin(CS_PIN);
  Root = SD.open(RootFile);
  SubFile = Root.openNextFile(); 
  SubFile = Root.openNextFile();
  Serial.println(SubFile.name());
  Audio.speakerPin = SpeakerPin;
  Audio.setVolume(5);
}


void loop() {
  // put your main code here, to run repeatedly:
  char ToDo = GetButPressed();
  if(ToDo != NullChar)
  {
      if(BackChar == ToDo)  
      {
        Root.rewindDirectory();
        SubFile = Root.openNextFile();
        SubFile = Root.openNextFile();
        Serial.println(SubFile.name());
      }
    	else if(PlayChar == ToDo)
    	{
    		Audio.play(SubFile.name());
    		Serial.print("Playing ");
    		Serial.println(SubFile.name());
    	}
    	else if(FrontChar == ToDo)
    	{
    		SubFile = Root.openNextFile();
    		Serial.println(SubFile.name());//
    	}
  }
}

char GetButPressed()
{
  char ReturnChar = NullChar;
  Back_But_State = getCurrentState(Back_But);
  Play_But_State = getCurrentState(Play_But);
  Front_But_State = getCurrentState(Front_But);
  if(LOW == BackPrevButState && HIGH == Back_But_State)
  {
    ReturnChar = BackChar;
  }
  BackPrevButState = Back_But_State;
  
  if(LOW == Play_Prev_But_State && HIGH == Play_But_State)
  {
	ReturnChar = PlayChar;
  }
  Play_Prev_But_State = Play_But_State;
  
  if(LOW == Front_Prev_But_State && HIGH == Front_But_State)
  {
	ReturnChar = FrontChar;
  }
  Front_Prev_But_State = Front_But_State;
  return ReturnChar;
}

boolean getCurrentState (int pinNumber)
{
  boolean currentState1 = LOW;
  boolean currentState2 = LOW;
  boolean FALSE = LOW;
  boolean TRUE = HIGH;
  boolean stable = FALSE;
  while (FALSE == stable)
  {
    currentState1 = digitalRead(pinNumber);
    delay(5);
    currentState2 = digitalRead(pinNumber);
    if (currentState1 == currentState2)
    {
      stable = TRUE;
    }
  }
  return currentState2;
}

